Bug 1867603 - ds/node-exporter roll out takes 100+ minutes on 250 node cluster
Summary: ds/node-exporter roll out takes 100+ minutes on 250 node cluster
Keywords:
Status: VERIFIED
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Monitoring
Version: 4.4
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: ---
: 4.6.0
Assignee: Sergiusz Urbaniak
QA Contact: Junqi Zhao
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-08-10 13:07 UTC by Scott Dodson
Modified: 2020-09-14 02:35 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Github openshift cluster-monitoring-operator pull 918 None closed Bug 1867603: ds/node-exporter: Set maxUnavailable 10% 2020-09-21 02:23:27 UTC

Description Scott Dodson 2020-08-10 13:07:33 UTC
Description of problem:
Because ds/node-exporter defaults to rollingUpdate maxUnavialable 1 the rollout is entirely serialized and thus very slow on large clusters. We can speed the rollout of daemonsets which don't immediately affect availability by allowing the maxUnavailable to scale with cluster size.

A quick test on a 250 node cluster shows that the current behavior takes around 100 minutes where as with maxUnavailable 10% it takes under 10 minutes.

Version-Release number of selected component (if applicable):
4.4

How reproducible:
100%

Steps to Reproduce:
1. Install a cluster that's got 20 or more hosts
2. Perform an upgrade
3. Observe that only one node-exporter pod is unavailable at once and the amount of time the upgrade takes. 

Actual results:
1 node-exporter unavailable at a time, slow rollout

Expected results:
10% node-exporter pods unavailable at most, faster / more parallel rollout

Additional info:

Comment 4 Junqi Zhao 2020-09-14 02:35:47 UTC
tested with 4.6.0-0.nightly-2020-09-12-230035, maxUnavailable for rollingUpdate is 10%
# oc -n openshift-monitoring get ds node-exporter -oyaml
--
  updateStrategy:
    rollingUpdate:
      maxUnavailable: 10%
    type: RollingUpdate


Note You need to log in before you can comment on or make changes to this bug.